<html>
<head>
<title>Ogre::D3D9VertexDeclaration Class Reference - OGRE Documentation</title> <meta http-equiv="Content-Type" content="text/html; charset=iso-8859-1"> 
<link type="text/css" rel="stylesheet" href="doxygen.css">
<link type="text/css" rel="stylesheet" href="tabs.css">
</head>

<body>
<!-- Generated by Doxygen 1.7.6.1 -->
  <div id="navrow1" class="tabs">
    <ul class="tablist">
      <li><a href="index.html"><span>Main&#160;Page</span></a></li>
      <li><a href="pages.html"><span>Related&#160;Pages</span></a></li>
      <li><a href="modules.html"><span>Modules</span></a></li>
      <li><a href="namespaces.html"><span>Namespaces</span></a></li>
      <li class="current"><a href="annotated.html"><span>Classes</span></a></li>
      <li><a href="files.html"><span>Files</span></a></li>
      <li><a href="dirs.html"><span>Directories</span></a></li>
    </ul>
  </div>
  <div id="navrow2" class="tabs2">
    <ul class="tablist">
      <li><a href="annotated.html"><span>Class&#160;List</span></a></li>
      <li><a href="classes.html"><span>Class&#160;Index</span></a></li>
      <li><a href="inherits.html"><span>Class&#160;Hierarchy</span></a></li>
      <li><a href="functions.html"><span>Class&#160;Members</span></a></li>
    </ul>
  </div>
  <div id="nav-path" class="navpath">
    <ul>
      <li class="navelem"><a class="el" href="namespaceOgre.html">Ogre</a>      </li>
      <li class="navelem"><a class="el" href="classOgre_1_1D3D9VertexDeclaration.html">D3D9VertexDeclaration</a>      </li>
    </ul>
  </div>
</div>
<div class="header">
  <div class="summary">
<a href="#pub-types">Public Types</a> &#124;
<a href="#pub-methods">Public Member Functions</a> &#124;
<a href="#pub-static-methods">Static Public Member Functions</a> &#124;
<a href="#pro-types">Protected Types</a> &#124;
<a href="#pro-methods">Protected Member Functions</a> &#124;
<a href="#pro-attribs">Protected Attributes</a>  </div>
  <div class="headertitle">
<div class="title">Ogre::D3D9VertexDeclaration Class Reference</div>  </div>
</div><!--header-->
<div class="contents">
<!-- doxytag: class="Ogre::D3D9VertexDeclaration" --><!-- doxytag: inherits="Ogre::VertexDeclaration,Ogre::D3D9Resource" -->
<p>Specialisation of <a class="el" href="classOgre_1_1VertexDeclaration.html" title="This class declares the format of a set of vertex inputs, which can be issued to the rendering API th...">VertexDeclaration</a> for D3D9.  
 <a href="classOgre_1_1D3D9VertexDeclaration.html#details">More...</a></p>

<p><code>#include &lt;<a class="el" href="OgreD3D9VertexDeclaration_8h_source.html">OgreD3D9VertexDeclaration.h</a>&gt;</code></p>
<div class="dynheader">
Inheritance diagram for Ogre::D3D9VertexDeclaration:</div>
<div class="dyncontent">
<div class="center"><img src="classOgre_1_1D3D9VertexDeclaration__inherit__graph.gif" border="0" usemap="#Ogre_1_1D3D9VertexDeclaration_inherit__map" alt="Inheritance graph"/></div>
<map name="Ogre_1_1D3D9VertexDeclaration_inherit__map" id="Ogre_1_1D3D9VertexDeclaration_inherit__map">
<area shape="rect" id="node2" href="classOgre_1_1VertexDeclaration.html" title="This class declares the format of a set of vertex inputs, which can be issued to the rendering API th..." alt="" coords="5,83,168,112"/><area shape="rect" id="node4" href="classOgre_1_1AllocatedObject.html" title="Superclass for all objects that wish to use custom memory allocators when their new / delete operator..." alt="" coords="28,5,145,35"/><area shape="rect" id="node6" href="classOgre_1_1D3D9Resource.html" title="Represents a Direct3D rendering resource." alt="" coords="192,83,339,112"/></map>
<center><span class="legend">[<a href="graph_legend.html">legend</a>]</span></center></div>

<p><a href="classOgre_1_1D3D9VertexDeclaration-members.html">List of all members.</a></p>
<table class="memberdecls">
<tr><td colspan="2"><h2><a name="pub-types"></a>
Public Types</h2></td></tr>
<tr><td class="memItemLeft" align="right" valign="top">typedef <a class="el" href="structOgre_1_1list.html">list</a>&lt; <a class="el" href="classOgre_1_1VertexElement.html">VertexElement</a> &gt;::type&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1VertexDeclaration.html#a3229cfa9d056740702853b27249c7181">VertexElementList</a></td></tr>
<tr><td class="mdescLeft">&#160;</td><td class="mdescRight">Defines the list of vertex elements that makes up this declaration.  <a href="#a3229cfa9d056740702853b27249c7181"></a><br/></td></tr>
<tr><td colspan="2"><h2><a name="pub-methods"></a>
Public Member Functions</h2></td></tr>
<tr><td class="memItemLeft" align="right" valign="top">&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1D3D9VertexDeclaration.html#a842f42e52d16d44819abb342fc182cad">D3D9VertexDeclaration</a> ()</td></tr>
<tr><td class="memItemLeft" align="right" valign="top">&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1D3D9VertexDeclaration.html#a6e35239737da934f62f69fad4c3bd290">~D3D9VertexDeclaration</a> ()</td></tr>
<tr><td class="memItemLeft" align="right" valign="top">const <a class="el" href="classOgre_1_1VertexElement.html">VertexElement</a> &amp;&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1D3D9VertexDeclaration.html#a9cb93660d7bedba9fe62a93da18ce6d0">addElement</a> (unsigned short source, size_t offset, <a class="el" href="group__RenderSystem.html#ga027109503a988ba85f4c63b55082907f">VertexElementType</a> theType, <a class="el" href="group__RenderSystem.html#ga0a62b3f2ede8992ff365bb013a8bc00d">VertexElementSemantic</a> semantic, unsigned short index=0)</td></tr>
<tr><td class="mdescLeft">&#160;</td><td class="mdescRight">See <a class="el" href="classOgre_1_1VertexDeclaration.html" title="This class declares the format of a set of vertex inputs, which can be issued to the rendering API th...">VertexDeclaration</a>.  <a href="#a9cb93660d7bedba9fe62a93da18ce6d0"></a><br/></td></tr>
<tr><td class="memItemLeft" align="right" valign="top">const <a class="el" href="classOgre_1_1VertexElement.html">VertexElement</a> &amp;&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1D3D9VertexDeclaration.html#a20073a271688d302e6f64fe564557c1a">insertElement</a> (unsigned short atPosition, unsigned short source, size_t offset, <a class="el" href="group__RenderSystem.html#ga027109503a988ba85f4c63b55082907f">VertexElementType</a> theType, <a class="el" href="group__RenderSystem.html#ga0a62b3f2ede8992ff365bb013a8bc00d">VertexElementSemantic</a> semantic, unsigned short index=0)</td></tr>
<tr><td class="mdescLeft">&#160;</td><td class="mdescRight">See <a class="el" href="classOgre_1_1VertexDeclaration.html" title="This class declares the format of a set of vertex inputs, which can be issued to the rendering API th...">VertexDeclaration</a>.  <a href="#a20073a271688d302e6f64fe564557c1a"></a><br/></td></tr>
<tr><td class="memItemLeft" align="right" valign="top">void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1D3D9VertexDeclaration.html#a8cb01902db67a5d34ccc02a5ff733fd1">removeElement</a> (unsigned short elem_index)</td></tr>
<tr><td class="mdescLeft">&#160;</td><td class="mdescRight">See <a class="el" href="classOgre_1_1VertexDeclaration.html" title="This class declares the format of a set of vertex inputs, which can be issued to the rendering API th...">VertexDeclaration</a>.  <a href="#a8cb01902db67a5d34ccc02a5ff733fd1"></a><br/></td></tr>
<tr><td class="memItemLeft" align="right" valign="top">void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1D3D9VertexDeclaration.html#aaf846d91970816cbbe04bb3def85e2b6">removeElement</a> (<a class="el" href="group__RenderSystem.html#ga0a62b3f2ede8992ff365bb013a8bc00d">VertexElementSemantic</a> semantic, unsigned short index=0)</td></tr>
<tr><td class="mdescLeft">&#160;</td><td class="mdescRight">See <a class="el" href="classOgre_1_1VertexDeclaration.html" title="This class declares the format of a set of vertex inputs, which can be issued to the rendering API th...">VertexDeclaration</a>.  <a href="#aaf846d91970816cbbe04bb3def85e2b6"></a><br/></td></tr>
<tr><td class="memItemLeft" align="right" valign="top">void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1D3D9VertexDeclaration.html#a266542b0e2a78904d671f615b03b8080">removeAllElements</a> (void)</td></tr>
<tr><td class="mdescLeft">&#160;</td><td class="mdescRight">See <a class="el" href="classOgre_1_1VertexDeclaration.html" title="This class declares the format of a set of vertex inputs, which can be issued to the rendering API th...">VertexDeclaration</a>.  <a href="#a266542b0e2a78904d671f615b03b8080"></a><br/></td></tr>
<tr><td class="memItemLeft" align="right" valign="top">void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1D3D9VertexDeclaration.html#aeb5a689761d0ee05e79015a4ee26917b">modifyElement</a> (unsigned short elem_index, unsigned short source, size_t offset, <a class="el" href="group__RenderSystem.html#ga027109503a988ba85f4c63b55082907f">VertexElementType</a> theType, <a class="el" href="group__RenderSystem.html#ga0a62b3f2ede8992ff365bb013a8bc00d">VertexElementSemantic</a> semantic, unsigned short index=0)</td></tr>
<tr><td class="mdescLeft">&#160;</td><td class="mdescRight">See <a class="el" href="classOgre_1_1VertexDeclaration.html" title="This class declares the format of a set of vertex inputs, which can be issued to the rendering API th...">VertexDeclaration</a>.  <a href="#aeb5a689761d0ee05e79015a4ee26917b"></a><br/></td></tr>
<tr><td class="memItemLeft" align="right" valign="top">virtual void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1D3D9VertexDeclaration.html#afe9b5394456063cae5b95d512cc54cc0">notifyOnDeviceCreate</a> (IDirect3DDevice9 *d3d9Device)</td></tr>
<tr><td class="memItemLeft" align="right" valign="top">virtual void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1D3D9VertexDeclaration.html#a5a91d9a841eca45392494b2444968029">notifyOnDeviceDestroy</a> (IDirect3DDevice9 *d3d9Device)</td></tr>
<tr><td class="memItemLeft" align="right" valign="top">IDirect3DVertexDeclaration9 *&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1D3D9VertexDeclaration.html#aa6da7c9f1902145e0725e348cb522699">getD3DVertexDeclaration</a> (<a class="el" href="classOgre_1_1VertexDeclaration.html">VertexDeclaration</a> *globalDeclaration, bool useGlobalInstancingVertexBufferIsAvailable)</td></tr>
<tr><td class="mdescLeft">&#160;</td><td class="mdescRight">Gets the D3D9-specific vertex declaration.  <a href="#aa6da7c9f1902145e0725e348cb522699"></a><br/></td></tr>
<tr><td class="memItemLeft" align="right" valign="top">size_t&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1VertexDeclaration.html#a4af70a10bb43da8b8816d18fe652ec58">getElementCount</a> (void) const </td></tr>
<tr><td class="mdescLeft">&#160;</td><td class="mdescRight">Get the number of elements in the declaration.  <a href="#a4af70a10bb43da8b8816d18fe652ec58"></a><br/></td></tr>
<tr><td class="memItemLeft" align="right" valign="top">const <a class="el" href="classOgre_1_1VertexDeclaration.html#a3229cfa9d056740702853b27249c7181">VertexElementList</a> &amp;&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1VertexDeclaration.html#aa9e3bde080e00f7cb9ee737259bb7fa2">getElements</a> (void) const </td></tr>
<tr><td class="mdescLeft">&#160;</td><td class="mdescRight">Gets read-only access to the list of vertex elements.  <a href="#aa9e3bde080e00f7cb9ee737259bb7fa2"></a><br/></td></tr>
<tr><td class="memItemLeft" align="right" valign="top">const <a class="el" href="classOgre_1_1VertexElement.html">VertexElement</a> *&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1VertexDeclaration.html#a31ee2f8508477014476518eb30f68267">getElement</a> (unsigned short index) const </td></tr>
<tr><td class="mdescLeft">&#160;</td><td class="mdescRight">Get a single element.  <a href="#a31ee2f8508477014476518eb30f68267"></a><br/></td></tr>
<tr><td class="memItemLeft" align="right" valign="top">void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1VertexDeclaration.html#a98cce285a45ba6f4cf817dcf46bfb588">sort</a> (void)</td></tr>
<tr><td class="mdescLeft">&#160;</td><td class="mdescRight">Sorts the elements in this list to be compatible with the maximum number of rendering APIs / graphics cards.  <a href="#a98cce285a45ba6f4cf817dcf46bfb588"></a><br/></td></tr>
<tr><td class="memItemLeft" align="right" valign="top">void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1VertexDeclaration.html#a260ecb704cfc32b82f248e382a53be47">closeGapsInSource</a> (void)</td></tr>
<tr><td class="mdescLeft">&#160;</td><td class="mdescRight">Remove any gaps in the source buffer list used by this declaration.  <a href="#a260ecb704cfc32b82f248e382a53be47"></a><br/></td></tr>
<tr><td class="memItemLeft" align="right" valign="top"><a class="el" href="classOgre_1_1VertexDeclaration.html">VertexDeclaration</a> *&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1VertexDeclaration.html#a7ee49d2d72f0b802fb94bebd216dd8ab">getAutoOrganisedDeclaration</a> (bool skeletalAnimation, bool vertexAnimation, bool vertexAnimationNormals) const </td></tr>
<tr><td class="mdescLeft">&#160;</td><td class="mdescRight">Generates a new <a class="el" href="classOgre_1_1VertexDeclaration.html" title="This class declares the format of a set of vertex inputs, which can be issued to the rendering API th...">VertexDeclaration</a> for optimal usage based on the current vertex declaration, which can be used with <a class="el" href="classOgre_1_1VertexData.html#a106603d9d4d6c2f6e0d5eb6c25eb7c32" title="Reorganises the data in the vertex buffers according to the new vertex declaration passed in...">VertexData::reorganiseBuffers</a> later if you wish, or simply used as a template.  <a href="#a7ee49d2d72f0b802fb94bebd216dd8ab"></a><br/></td></tr>
<tr><td class="memItemLeft" align="right" valign="top">unsigned short&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1VertexDeclaration.html#a2aca53e4f9ccb1cef8d070b037e3b649">getMaxSource</a> (void) const </td></tr>
<tr><td class="mdescLeft">&#160;</td><td class="mdescRight">Gets the index of the highest source value referenced by this declaration.  <a href="#a2aca53e4f9ccb1cef8d070b037e3b649"></a><br/></td></tr>
<tr><td class="memItemLeft" align="right" valign="top">virtual const <a class="el" href="classOgre_1_1VertexElement.html">VertexElement</a> *&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1VertexDeclaration.html#a3ccfd23af715e4ba40a06edd467d5475">findElementBySemantic</a> (<a class="el" href="group__RenderSystem.html#ga0a62b3f2ede8992ff365bb013a8bc00d">VertexElementSemantic</a> sem, unsigned short index=0) const </td></tr>
<tr><td class="mdescLeft">&#160;</td><td class="mdescRight">Finds a <a class="el" href="classOgre_1_1VertexElement.html" title="This class declares the usage of a single vertex buffer as a component of a complete VertexDeclaratio...">VertexElement</a> with the given semantic, and index if there is more than one element with the same semantic.  <a href="#a3ccfd23af715e4ba40a06edd467d5475"></a><br/></td></tr>
<tr><td class="memItemLeft" align="right" valign="top">virtual <a class="el" href="classOgre_1_1VertexDeclaration.html#a3229cfa9d056740702853b27249c7181">VertexElementList</a>&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1VertexDeclaration.html#a293447fa4009ed26af12b47b8cd6415c">findElementsBySource</a> (unsigned short source) const </td></tr>
<tr><td class="mdescLeft">&#160;</td><td class="mdescRight">Based on the current elements, gets the size of the vertex for a given buffer source.  <a href="#a293447fa4009ed26af12b47b8cd6415c"></a><br/></td></tr>
<tr><td class="memItemLeft" align="right" valign="top">virtual size_t&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1VertexDeclaration.html#ad39445c408cde1362822577ba0c485c2">getVertexSize</a> (unsigned short source) const </td></tr>
<tr><td class="mdescLeft">&#160;</td><td class="mdescRight">Gets the vertex size defined by this declaration for a given source.  <a href="#ad39445c408cde1362822577ba0c485c2"></a><br/></td></tr>
<tr><td class="memItemLeft" align="right" valign="top">virtual unsigned short&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1VertexDeclaration.html#a8932fb5a831e8ac471bd5f4b2a7351b8">getNextFreeTextureCoordinate</a> () const </td></tr>
<tr><td class="mdescLeft">&#160;</td><td class="mdescRight">Return the index of the next free texture coordinate set which may be added to this declaration.  <a href="#a8932fb5a831e8ac471bd5f4b2a7351b8"></a><br/></td></tr>
<tr><td class="memItemLeft" align="right" valign="top">virtual <a class="el" href="classOgre_1_1VertexDeclaration.html">VertexDeclaration</a> *&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1VertexDeclaration.html#ad75e99bdec09b033ef250b3d2c5296f2">clone</a> (<a class="el" href="classOgre_1_1HardwareBufferManagerBase.html">HardwareBufferManagerBase</a> *mgr=0) const </td></tr>
<tr><td class="mdescLeft">&#160;</td><td class="mdescRight">Clones this declaration.  <a href="#ad75e99bdec09b033ef250b3d2c5296f2"></a><br/></td></tr>
<tr><td class="memItemLeft" align="right" valign="top">bool&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1VertexDeclaration.html#aee364dc39b2dfdbff4a5b135e5e5ef39">operator==</a> (const <a class="el" href="classOgre_1_1VertexDeclaration.html">VertexDeclaration</a> &amp;rhs) const </td></tr>
<tr><td class="memItemLeft" align="right" valign="top">bool&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1VertexDeclaration.html#a64989816c9979aac5a5416d488d547d5">operator!=</a> (const <a class="el" href="classOgre_1_1VertexDeclaration.html">VertexDeclaration</a> &amp;rhs) const </td></tr>
<tr><td class="memItemLeft" align="right" valign="top">void *&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1AllocatedObject.html#a421b197ca3a38da17e2eb1531a645fa2">operator new</a> (size_t sz, const char *file, int line, const char *func)</td></tr>
<tr><td class="mdescLeft">&#160;</td><td class="mdescRight">operator new, with debug line info  <a href="#a421b197ca3a38da17e2eb1531a645fa2"></a><br/></td></tr>
<tr><td class="memItemLeft" align="right" valign="top">void *&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1AllocatedObject.html#ac4bdf968b7b9af8a5239a27da73d5711">operator new</a> (size_t sz)</td></tr>
<tr><td class="memItemLeft" align="right" valign="top">void *&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1AllocatedObject.html#ab78a921e54419be677839cdf15d1f0b8">operator new</a> (size_t sz, void *ptr)</td></tr>
<tr><td class="mdescLeft">&#160;</td><td class="mdescRight">placement operator new  <a href="#ab78a921e54419be677839cdf15d1f0b8"></a><br/></td></tr>
<tr><td class="memItemLeft" align="right" valign="top">void *&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1AllocatedObject.html#a4be37baef81876985aa1071ad5acc6dd">operator new[]</a> (size_t sz, const char *file, int line, const char *func)</td></tr>
<tr><td class="mdescLeft">&#160;</td><td class="mdescRight">array operator new, with debug line info  <a href="#a4be37baef81876985aa1071ad5acc6dd"></a><br/></td></tr>
<tr><td class="memItemLeft" align="right" valign="top">void *&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1AllocatedObject.html#afa2943846ba6a2b5824a12857139cf5e">operator new[]</a> (size_t sz)</td></tr>
<tr><td class="memItemLeft" align="right" valign="top">void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1AllocatedObject.html#a8357fe4fb4849772b94baa4bf47c7ded">operator delete</a> (void *ptr)</td></tr>
<tr><td class="memItemLeft" align="right" valign="top">void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1AllocatedObject.html#a1c727e879a260c37b00ce5505fe8e144">operator delete</a> (void *ptr, void *)</td></tr>
<tr><td class="memItemLeft" align="right" valign="top">void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1AllocatedObject.html#acb46d4b0a597156d9ba5abc39d127792">operator delete</a> (void *ptr, const char *, int, const char *)</td></tr>
<tr><td class="memItemLeft" align="right" valign="top">void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1AllocatedObject.html#a93e6a86dde5483c053ca0f2a85bbfd6c">operator delete[]</a> (void *ptr)</td></tr>
<tr><td class="memItemLeft" align="right" valign="top">void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1AllocatedObject.html#a595ea4c05da8aa987d3800e65d23355d">operator delete[]</a> (void *ptr, const char *, int, const char *)</td></tr>
<tr><td class="memItemLeft" align="right" valign="top">virtual void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1D3D9Resource.html#a8d55f1d5ce61a1b796d8d86dd3c69fdb">notifyOnDeviceLost</a> (IDirect3DDevice9 *d3d9Device)</td></tr>
<tr><td class="memItemLeft" align="right" valign="top">virtual void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1D3D9Resource.html#a9008da922e8b8762ac284cc1f08a0749">notifyOnDeviceReset</a> (IDirect3DDevice9 *d3d9Device)</td></tr>
<tr><td colspan="2"><h2><a name="pub-static-methods"></a>
Static Public Member Functions</h2></td></tr>
<tr><td class="memItemLeft" align="right" valign="top">static bool&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1VertexDeclaration.html#a670466fe9bcfc426ccefb5395a3a82ef">vertexElementLess</a> (const <a class="el" href="classOgre_1_1VertexElement.html">VertexElement</a> &amp;e1, const <a class="el" href="classOgre_1_1VertexElement.html">VertexElement</a> &amp;e2)</td></tr>
<tr><td class="mdescLeft">&#160;</td><td class="mdescRight">Sort routine for vertex elements.  <a href="#a670466fe9bcfc426ccefb5395a3a82ef"></a><br/></td></tr>
<tr><td class="memItemLeft" align="right" valign="top">static void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1D3D9Resource.html#aa97afae987b0c0f16c3e232a7317fad5">lockDeviceAccess</a> ()</td></tr>
<tr><td class="memItemLeft" align="right" valign="top">static void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1D3D9Resource.html#a6fc9c0ebe4a4c559b172f25f3b5dc9d8">unlockDeviceAccess</a> ()</td></tr>
<tr><td colspan="2"><h2><a name="pro-types"></a>
Protected Types</h2></td></tr>
<tr><td class="memItemLeft" align="right" valign="top">typedef <a class="el" href="structOgre_1_1map.html">map</a>&lt; IDirect3DDevice9 <br class="typebreak"/>
*, IDirect3DVertexDeclaration9 * &gt;<br class="typebreak"/>
::type&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1D3D9VertexDeclaration.html#acb454d7ad730f5018514cf2204d02a2d">DeviceToDeclarationMap</a></td></tr>
<tr><td class="memItemLeft" align="right" valign="top">typedef <br class="typebreak"/>
DeviceToDeclarationMap::iterator&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1D3D9VertexDeclaration.html#ae1de70597b4c9c1b53d1a2b8b9c74dcb">DeviceToDeclarationIterator</a></td></tr>
<tr><td colspan="2"><h2><a name="pro-methods"></a>
Protected Member Functions</h2></td></tr>
<tr><td class="memItemLeft" align="right" valign="top">void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1D3D9VertexDeclaration.html#a7cdd5882972af0c2730d814daeaa93e4">releaseDeclaration</a> ()</td></tr>
<tr><td class="memItemLeft" align="right" valign="top">void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1D3D9VertexDeclaration.html#ad024aac9e82c079804563b2777ae8d27">convertElement</a> (const <a class="el" href="classOgre_1_1VertexElement.html">VertexElement</a> &amp;element, D3DVERTEXELEMENT9 &amp;dxElement)</td></tr>
<tr><td colspan="2"><h2><a name="pro-attribs"></a>
Protected Attributes</h2></td></tr>
<tr><td class="memItemLeft" align="right" valign="top"><a class="el" href="classOgre_1_1D3D9VertexDeclaration.html#acb454d7ad730f5018514cf2204d02a2d">DeviceToDeclarationMap</a>&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1D3D9VertexDeclaration.html#aa5d8572399731ad358b8eeb4039e889c">mMapDeviceToDeclaration</a></td></tr>
<tr><td class="memItemLeft" align="right" valign="top"><a class="el" href="classOgre_1_1VertexDeclaration.html">VertexDeclaration</a> *&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1D3D9VertexDeclaration.html#a6f366f7e06ffc70919f964d8ec7e597c">mLastUsedGlobalDeclaration</a></td></tr>
<tr><td class="memItemLeft" align="right" valign="top">bool&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1D3D9VertexDeclaration.html#af135e2be5d157faf75601b06d5c1f57c">mUsedGlobalDeclaration</a></td></tr>
<tr><td class="memItemLeft" align="right" valign="top"><a class="el" href="classOgre_1_1VertexDeclaration.html#a3229cfa9d056740702853b27249c7181">VertexElementList</a>&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1VertexDeclaration.html#adc48aa31318d2384866eab90ee8406d5">mElementList</a></td></tr>
</table>
<hr/><a name="details" id="details"></a><h2>Detailed Description</h2>
<div class="textblock"><p>Specialisation of <a class="el" href="classOgre_1_1VertexDeclaration.html" title="This class declares the format of a set of vertex inputs, which can be issued to the rendering API th...">VertexDeclaration</a> for D3D9. </p>

<p>Definition at line <a class="el" href="OgreD3D9VertexDeclaration_8h_source.html#l00038">38</a> of file <a class="el" href="OgreD3D9VertexDeclaration_8h_source.html">OgreD3D9VertexDeclaration.h</a>.</p>
</div><hr/><h2>Member Typedef Documentation</h2>
<a class="anchor" id="ae1de70597b4c9c1b53d1a2b8b9c74dcb"></a><!-- doxytag: member="Ogre::D3D9VertexDeclaration::DeviceToDeclarationIterator" ref="ae1de70597b4c9c1b53d1a2b8b9c74dcb" args="" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">typedef DeviceToDeclarationMap::iterator <a class="el" href="classOgre_1_1D3D9VertexDeclaration.html#ae1de70597b4c9c1b53d1a2b8b9c74dcb">Ogre::D3D9VertexDeclaration::DeviceToDeclarationIterator</a><code> [protected]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>Definition at line <a class="el" href="OgreD3D9VertexDeclaration_8h_source.html#l00083">83</a> of file <a class="el" href="OgreD3D9VertexDeclaration_8h_source.html">OgreD3D9VertexDeclaration.h</a>.</p>

</div>
</div>
<a class="anchor" id="acb454d7ad730f5018514cf2204d02a2d"></a><!-- doxytag: member="Ogre::D3D9VertexDeclaration::DeviceToDeclarationMap" ref="acb454d7ad730f5018514cf2204d02a2d" args="" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">typedef <a class="el" href="structOgre_1_1map.html">map</a>&lt;IDirect3DDevice9*, IDirect3DVertexDeclaration9*&gt;::type <a class="el" href="classOgre_1_1D3D9VertexDeclaration.html#acb454d7ad730f5018514cf2204d02a2d">Ogre::D3D9VertexDeclaration::DeviceToDeclarationMap</a><code> [protected]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>Definition at line <a class="el" href="OgreD3D9VertexDeclaration_8h_source.html#l00082">82</a> of file <a class="el" href="OgreD3D9VertexDeclaration_8h_source.html">OgreD3D9VertexDeclaration.h</a>.</p>

</div>
</div>
<a class="anchor" id="a3229cfa9d056740702853b27249c7181"></a><!-- doxytag: member="Ogre::D3D9VertexDeclaration::VertexElementList" ref="a3229cfa9d056740702853b27249c7181" args="" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">typedef <a class="el" href="structOgre_1_1list.html">list</a>&lt;<a class="el" href="classOgre_1_1VertexElement.html">VertexElement</a>&gt;::type <a class="el" href="classOgre_1_1VertexDeclaration.html#a3229cfa9d056740702853b27249c7181">Ogre::VertexDeclaration::VertexElementList</a><code> [inherited]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>Defines the list of vertex elements that makes up this declaration. </p>

<p>Definition at line <a class="el" href="OgreHardwareVertexBuffer_8h_source.html#l00321">321</a> of file <a class="el" href="OgreHardwareVertexBuffer_8h_source.html">OgreHardwareVertexBuffer.h</a>.</p>

</div>
</div>
<hr/><h2>Constructor &amp; Destructor Documentation</h2>
<a class="anchor" id="a842f42e52d16d44819abb342fc182cad"></a><!-- doxytag: member="Ogre::D3D9VertexDeclaration::D3D9VertexDeclaration" ref="a842f42e52d16d44819abb342fc182cad" args="()" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname"><a class="el" href="classOgre_1_1D3D9VertexDeclaration.html#a842f42e52d16d44819abb342fc182cad">Ogre::D3D9VertexDeclaration::D3D9VertexDeclaration</a> </td>
          <td>(</td>
          <td class="paramname"></td><td>)</td>
          <td></td>
        </tr>
      </table>
</div>
<div class="memdoc">

</div>
</div>
<a class="anchor" id="a6e35239737da934f62f69fad4c3bd290"></a><!-- doxytag: member="Ogre::D3D9VertexDeclaration::~D3D9VertexDeclaration" ref="a6e35239737da934f62f69fad4c3bd290" args="()" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname"><a class="el" href="classOgre_1_1D3D9VertexDeclaration.html#a6e35239737da934f62f69fad4c3bd290">Ogre::D3D9VertexDeclaration::~D3D9VertexDeclaration</a> </td>
          <td>(</td>
          <td class="paramname"></td><td>)</td>
          <td></td>
        </tr>
      </table>
</div>
<div class="memdoc">

</div>
</div>
<hr/><h2>Member Function Documentation</h2>
<a class="anchor" id="a9cb93660d7bedba9fe62a93da18ce6d0"></a><!-- doxytag: member="Ogre::D3D9VertexDeclaration::addElement" ref="a9cb93660d7bedba9fe62a93da18ce6d0" args="(unsigned short source, size_t offset, VertexElementType theType, VertexElementSemantic semantic, unsigned short index=0)" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">const <a class="el" href="classOgre_1_1VertexElement.html">VertexElement</a>&amp; <a class="el" href="classOgre_1_1D3D9VertexDeclaration.html#a9cb93660d7bedba9fe62a93da18ce6d0">Ogre::D3D9VertexDeclaration::addElement</a> </td>
          <td>(</td>
          <td class="paramtype">unsigned short&#160;</td>
          <td class="paramname"><em>source</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">size_t&#160;</td>
          <td class="paramname"><em>offset</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype"><a class="el" href="group__RenderSystem.html#ga027109503a988ba85f4c63b55082907f">VertexElementType</a>&#160;</td>
          <td class="paramname"><em>theType</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype"><a class="el" href="group__RenderSystem.html#ga0a62b3f2ede8992ff365bb013a8bc00d">VertexElementSemantic</a>&#160;</td>
          <td class="paramname"><em>semantic</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">unsigned short&#160;</td>
          <td class="paramname"><em>index</em> = <code>0</code>&#160;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td><code> [virtual]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>See <a class="el" href="classOgre_1_1VertexDeclaration.html" title="This class declares the format of a set of vertex inputs, which can be issued to the rendering API th...">VertexDeclaration</a>. </p>

<p>Reimplemented from <a class="el" href="classOgre_1_1VertexDeclaration.html#ae789acf4f4a63d8638fc23cb4e26239f">Ogre::VertexDeclaration</a>.</p>

</div>
</div>
<a class="anchor" id="ad75e99bdec09b033ef250b3d2c5296f2"></a><!-- doxytag: member="Ogre::D3D9VertexDeclaration::clone" ref="ad75e99bdec09b033ef250b3d2c5296f2" args="(HardwareBufferManagerBase *mgr=0) const " -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">virtual <a class="el" href="classOgre_1_1VertexDeclaration.html">VertexDeclaration</a>* <a class="el" href="classOgre_1_1VertexDeclaration.html#ad75e99bdec09b033ef250b3d2c5296f2">Ogre::VertexDeclaration::clone</a> </td>
          <td>(</td>
          <td class="paramtype"><a class="el" href="classOgre_1_1HardwareBufferManagerBase.html">HardwareBufferManagerBase</a> *&#160;</td>
          <td class="paramname"><em>mgr</em> = <code>0</code></td><td>)</td>
          <td> const<code> [virtual, inherited]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>Clones this declaration. </p>
<dl class="params"><dt><b>Parameters:</b></dt><dd>
  <table class="params">
    <tr><td class="paramname">mgr</td><td>Optional <a class="el" href="classOgre_1_1HardwareBufferManager.html" title="Singleton wrapper for hardware buffer manager.">HardwareBufferManager</a> to use for creating the clone (if null, use the current default). </td></tr>
  </table>
  </dd>
</dl>

</div>
</div>
<a class="anchor" id="a260ecb704cfc32b82f248e382a53be47"></a><!-- doxytag: member="Ogre::D3D9VertexDeclaration::closeGapsInSource" ref="a260ecb704cfc32b82f248e382a53be47" args="(void)" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">void <a class="el" href="classOgre_1_1VertexDeclaration.html#a260ecb704cfc32b82f248e382a53be47">Ogre::VertexDeclaration::closeGapsInSource</a> </td>
          <td>(</td>
          <td class="paramtype">void&#160;</td>
          <td class="paramname"></td><td>)</td>
          <td><code> [inherited]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>Remove any gaps in the source buffer list used by this declaration. </p>
<dl class="remark"><dt><b>Remarks:</b></dt><dd>This is useful if you've modified a declaration and want to remove any gaps in the list of buffers being used. Note, however, that if this declaration is already being used with a <a class="el" href="classOgre_1_1VertexBufferBinding.html" title="Records the state of all the vertex buffer bindings required to provide a vertex declaration with the...">VertexBufferBinding</a>, you will need to alter that too. This method is mainly useful when reorganising buffers based on an altered declaration. </dd></dl>
<dl class="note"><dt><b>Note:</b></dt><dd>This will cause the vertex declaration to be re-sorted. </dd></dl>

</div>
</div>
<a class="anchor" id="ad024aac9e82c079804563b2777ae8d27"></a><!-- doxytag: member="Ogre::D3D9VertexDeclaration::convertElement" ref="ad024aac9e82c079804563b2777ae8d27" args="(const VertexElement &amp;element, D3DVERTEXELEMENT9 &amp;dxElement)" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">void <a class="el" href="classOgre_1_1D3D9VertexDeclaration.html#ad024aac9e82c079804563b2777ae8d27">Ogre::D3D9VertexDeclaration::convertElement</a> </td>
          <td>(</td>
          <td class="paramtype">const <a class="el" href="classOgre_1_1VertexElement.html">VertexElement</a> &amp;&#160;</td>
          <td class="paramname"><em>element</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">D3DVERTEXELEMENT9 &amp;&#160;</td>
          <td class="paramname"><em>dxElement</em>&#160;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td><code> [protected]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">

</div>
</div>
<a class="anchor" id="a3ccfd23af715e4ba40a06edd467d5475"></a><!-- doxytag: member="Ogre::D3D9VertexDeclaration::findElementBySemantic" ref="a3ccfd23af715e4ba40a06edd467d5475" args="(VertexElementSemantic sem, unsigned short index=0) const " -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">virtual const <a class="el" href="classOgre_1_1VertexElement.html">VertexElement</a>* <a class="el" href="classOgre_1_1VertexDeclaration.html#a3ccfd23af715e4ba40a06edd467d5475">Ogre::VertexDeclaration::findElementBySemantic</a> </td>
          <td>(</td>
          <td class="paramtype"><a class="el" href="group__RenderSystem.html#ga0a62b3f2ede8992ff365bb013a8bc00d">VertexElementSemantic</a>&#160;</td>
          <td class="paramname"><em>sem</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">unsigned short&#160;</td>
          <td class="paramname"><em>index</em> = <code>0</code>&#160;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td> const<code> [virtual, inherited]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>Finds a <a class="el" href="classOgre_1_1VertexElement.html" title="This class declares the usage of a single vertex buffer as a component of a complete VertexDeclaratio...">VertexElement</a> with the given semantic, and index if there is more than one element with the same semantic. </p>
<dl class="remark"><dt><b>Remarks:</b></dt><dd>If the element is not found, this method returns null. </dd></dl>

</div>
</div>
<a class="anchor" id="a293447fa4009ed26af12b47b8cd6415c"></a><!-- doxytag: member="Ogre::D3D9VertexDeclaration::findElementsBySource" ref="a293447fa4009ed26af12b47b8cd6415c" args="(unsigned short source) const " -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">virtual <a class="el" href="classOgre_1_1VertexDeclaration.html#a3229cfa9d056740702853b27249c7181">VertexElementList</a> <a class="el" href="classOgre_1_1VertexDeclaration.html#a293447fa4009ed26af12b47b8cd6415c">Ogre::VertexDeclaration::findElementsBySource</a> </td>
          <td>(</td>
          <td class="paramtype">unsigned short&#160;</td>
          <td class="paramname"><em>source</em></td><td>)</td>
          <td> const<code> [virtual, inherited]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>Based on the current elements, gets the size of the vertex for a given buffer source. </p>
<dl class="params"><dt><b>Parameters:</b></dt><dd>
  <table class="params">
    <tr><td class="paramname">source</td><td>The buffer binding index for which to get the vertex size. Gets a list of elements which use a given source. </td></tr>
  </table>
  </dd>
</dl>
<dl class="remark"><dt><b>Remarks:</b></dt><dd>Note that the list of elements is returned by value therefore is separate from the declaration as soon as this method returns. </dd></dl>

</div>
</div>
<a class="anchor" id="a7ee49d2d72f0b802fb94bebd216dd8ab"></a><!-- doxytag: member="Ogre::D3D9VertexDeclaration::getAutoOrganisedDeclaration" ref="a7ee49d2d72f0b802fb94bebd216dd8ab" args="(bool skeletalAnimation, bool vertexAnimation, bool vertexAnimationNormals) const " -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname"><a class="el" href="classOgre_1_1VertexDeclaration.html">VertexDeclaration</a>* <a class="el" href="classOgre_1_1VertexDeclaration.html#a7ee49d2d72f0b802fb94bebd216dd8ab">Ogre::VertexDeclaration::getAutoOrganisedDeclaration</a> </td>
          <td>(</td>
          <td class="paramtype">bool&#160;</td>
          <td class="paramname"><em>skeletalAnimation</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">bool&#160;</td>
          <td class="paramname"><em>vertexAnimation</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">bool&#160;</td>
          <td class="paramname"><em>vertexAnimationNormals</em>&#160;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td> const<code> [inherited]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>Generates a new <a class="el" href="classOgre_1_1VertexDeclaration.html" title="This class declares the format of a set of vertex inputs, which can be issued to the rendering API th...">VertexDeclaration</a> for optimal usage based on the current vertex declaration, which can be used with <a class="el" href="classOgre_1_1VertexData.html#a106603d9d4d6c2f6e0d5eb6c25eb7c32" title="Reorganises the data in the vertex buffers according to the new vertex declaration passed in...">VertexData::reorganiseBuffers</a> later if you wish, or simply used as a template. </p>
<dl class="remark"><dt><b>Remarks:</b></dt><dd>Different buffer organisations and buffer usages will be returned depending on the parameters passed to this method. </dd></dl>
<dl class="params"><dt><b>Parameters:</b></dt><dd>
  <table class="params">
    <tr><td class="paramname">skeletalAnimation</td><td>Whether this vertex data is going to be skeletally animated </td></tr>
    <tr><td class="paramname">vertexAnimation</td><td>Whether this vertex data is going to be vertex animated </td></tr>
    <tr><td class="paramname">vertexAnimationNormals</td><td>Whether vertex data animation is going to include normals animation </td></tr>
  </table>
  </dd>
</dl>

</div>
</div>
<a class="anchor" id="aa6da7c9f1902145e0725e348cb522699"></a><!-- doxytag: member="Ogre::D3D9VertexDeclaration::getD3DVertexDeclaration" ref="aa6da7c9f1902145e0725e348cb522699" args="(VertexDeclaration *globalDeclaration, bool useGlobalInstancingVertexBufferIsAvailable)" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">IDirect3DVertexDeclaration9* <a class="el" href="classOgre_1_1D3D9VertexDeclaration.html#aa6da7c9f1902145e0725e348cb522699">Ogre::D3D9VertexDeclaration::getD3DVertexDeclaration</a> </td>
          <td>(</td>
          <td class="paramtype"><a class="el" href="classOgre_1_1VertexDeclaration.html">VertexDeclaration</a> *&#160;</td>
          <td class="paramname"><em>globalDeclaration</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">bool&#160;</td>
          <td class="paramname"><em>useGlobalInstancingVertexBufferIsAvailable</em>&#160;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>Gets the D3D9-specific vertex declaration. </p>

</div>
</div>
<a class="anchor" id="a31ee2f8508477014476518eb30f68267"></a><!-- doxytag: member="Ogre::D3D9VertexDeclaration::getElement" ref="a31ee2f8508477014476518eb30f68267" args="(unsigned short index) const " -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">const <a class="el" href="classOgre_1_1VertexElement.html">VertexElement</a>* <a class="el" href="classOgre_1_1VertexDeclaration.html#a31ee2f8508477014476518eb30f68267">Ogre::VertexDeclaration::getElement</a> </td>
          <td>(</td>
          <td class="paramtype">unsigned short&#160;</td>
          <td class="paramname"><em>index</em></td><td>)</td>
          <td> const<code> [inherited]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>Get a single element. </p>

</div>
</div>
<a class="anchor" id="a4af70a10bb43da8b8816d18fe652ec58"></a><!-- doxytag: member="Ogre::D3D9VertexDeclaration::getElementCount" ref="a4af70a10bb43da8b8816d18fe652ec58" args="(void) const " -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">size_t <a class="el" href="classOgre_1_1VertexDeclaration.html#a4af70a10bb43da8b8816d18fe652ec58">Ogre::VertexDeclaration::getElementCount</a> </td>
          <td>(</td>
          <td class="paramtype">void&#160;</td>
          <td class="paramname"></td><td>)</td>
          <td> const<code> [inherited]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>Get the number of elements in the declaration. </p>

<p>Definition at line <a class="el" href="OgreHardwareVertexBuffer_8h_source.html#l00332">332</a> of file <a class="el" href="OgreHardwareVertexBuffer_8h_source.html">OgreHardwareVertexBuffer.h</a>.</p>

</div>
</div>
<a class="anchor" id="aa9e3bde080e00f7cb9ee737259bb7fa2"></a><!-- doxytag: member="Ogre::D3D9VertexDeclaration::getElements" ref="aa9e3bde080e00f7cb9ee737259bb7fa2" args="(void) const " -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">const <a class="el" href="classOgre_1_1VertexDeclaration.html#a3229cfa9d056740702853b27249c7181">VertexElementList</a>&amp; <a class="el" href="classOgre_1_1VertexDeclaration.html#aa9e3bde080e00f7cb9ee737259bb7fa2">Ogre::VertexDeclaration::getElements</a> </td>
          <td>(</td>
          <td class="paramtype">void&#160;</td>
          <td class="paramname"></td><td>)</td>
          <td> const<code> [inherited]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>Gets read-only access to the list of vertex elements. </p>

</div>
</div>
<a class="anchor" id="a2aca53e4f9ccb1cef8d070b037e3b649"></a><!-- doxytag: member="Ogre::D3D9VertexDeclaration::getMaxSource" ref="a2aca53e4f9ccb1cef8d070b037e3b649" args="(void) const " -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">unsigned short <a class="el" href="classOgre_1_1VertexDeclaration.html#a2aca53e4f9ccb1cef8d070b037e3b649">Ogre::VertexDeclaration::getMaxSource</a> </td>
          <td>(</td>
          <td class="paramtype">void&#160;</td>
          <td class="paramname"></td><td>)</td>
          <td> const<code> [inherited]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>Gets the index of the highest source value referenced by this declaration. </p>

</div>
</div>
<a class="anchor" id="a8932fb5a831e8ac471bd5f4b2a7351b8"></a><!-- doxytag: member="Ogre::D3D9VertexDeclaration::getNextFreeTextureCoordinate" ref="a8932fb5a831e8ac471bd5f4b2a7351b8" args="() const " -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">virtual unsigned short <a class="el" href="classOgre_1_1VertexDeclaration.html#a8932fb5a831e8ac471bd5f4b2a7351b8">Ogre::VertexDeclaration::getNextFreeTextureCoordinate</a> </td>
          <td>(</td>
          <td class="paramname"></td><td>)</td>
          <td> const<code> [virtual, inherited]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>Return the index of the next free texture coordinate set which may be added to this declaration. </p>

</div>
</div>
<a class="anchor" id="ad39445c408cde1362822577ba0c485c2"></a><!-- doxytag: member="Ogre::D3D9VertexDeclaration::getVertexSize" ref="ad39445c408cde1362822577ba0c485c2" args="(unsigned short source) const " -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">virtual size_t <a class="el" href="classOgre_1_1VertexDeclaration.html#ad39445c408cde1362822577ba0c485c2">Ogre::VertexDeclaration::getVertexSize</a> </td>
          <td>(</td>
          <td class="paramtype">unsigned short&#160;</td>
          <td class="paramname"><em>source</em></td><td>)</td>
          <td> const<code> [virtual, inherited]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>Gets the vertex size defined by this declaration for a given source. </p>

</div>
</div>
<a class="anchor" id="a20073a271688d302e6f64fe564557c1a"></a><!-- doxytag: member="Ogre::D3D9VertexDeclaration::insertElement" ref="a20073a271688d302e6f64fe564557c1a" args="(unsigned short atPosition, unsigned short source, size_t offset, VertexElementType theType, VertexElementSemantic semantic, unsigned short index=0)" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">const <a class="el" href="classOgre_1_1VertexElement.html">VertexElement</a>&amp; <a class="el" href="classOgre_1_1D3D9VertexDeclaration.html#a20073a271688d302e6f64fe564557c1a">Ogre::D3D9VertexDeclaration::insertElement</a> </td>
          <td>(</td>
          <td class="paramtype">unsigned short&#160;</td>
          <td class="paramname"><em>atPosition</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">unsigned short&#160;</td>
          <td class="paramname"><em>source</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">size_t&#160;</td>
          <td class="paramname"><em>offset</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype"><a class="el" href="group__RenderSystem.html#ga027109503a988ba85f4c63b55082907f">VertexElementType</a>&#160;</td>
          <td class="paramname"><em>theType</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype"><a class="el" href="group__RenderSystem.html#ga0a62b3f2ede8992ff365bb013a8bc00d">VertexElementSemantic</a>&#160;</td>
          <td class="paramname"><em>semantic</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">unsigned short&#160;</td>
          <td class="paramname"><em>index</em> = <code>0</code>&#160;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td><code> [virtual]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>See <a class="el" href="classOgre_1_1VertexDeclaration.html" title="This class declares the format of a set of vertex inputs, which can be issued to the rendering API th...">VertexDeclaration</a>. </p>

<p>Reimplemented from <a class="el" href="classOgre_1_1VertexDeclaration.html#ab11e10c594cd765a0d8389b9e96ec24e">Ogre::VertexDeclaration</a>.</p>

</div>
</div>
<a class="anchor" id="aa97afae987b0c0f16c3e232a7317fad5"></a><!-- doxytag: member="Ogre::D3D9VertexDeclaration::lockDeviceAccess" ref="aa97afae987b0c0f16c3e232a7317fad5" args="()" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">static void <a class="el" href="classOgre_1_1D3D9Resource.html#aa97afae987b0c0f16c3e232a7317fad5">Ogre::D3D9Resource::lockDeviceAccess</a> </td>
          <td>(</td>
          <td class="paramname"></td><td>)</td>
          <td><code> [static, inherited]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">

</div>
</div>
<a class="anchor" id="aeb5a689761d0ee05e79015a4ee26917b"></a><!-- doxytag: member="Ogre::D3D9VertexDeclaration::modifyElement" ref="aeb5a689761d0ee05e79015a4ee26917b" args="(unsigned short elem_index, unsigned short source, size_t offset, VertexElementType theType, VertexElementSemantic semantic, unsigned short index=0)" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">void <a class="el" href="classOgre_1_1D3D9VertexDeclaration.html#aeb5a689761d0ee05e79015a4ee26917b">Ogre::D3D9VertexDeclaration::modifyElement</a> </td>
          <td>(</td>
          <td class="paramtype">unsigned short&#160;</td>
          <td class="paramname"><em>elem_index</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">unsigned short&#160;</td>
          <td class="paramname"><em>source</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">size_t&#160;</td>
          <td class="paramname"><em>offset</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype"><a class="el" href="group__RenderSystem.html#ga027109503a988ba85f4c63b55082907f">VertexElementType</a>&#160;</td>
          <td class="paramname"><em>theType</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype"><a class="el" href="group__RenderSystem.html#ga0a62b3f2ede8992ff365bb013a8bc00d">VertexElementSemantic</a>&#160;</td>
          <td class="paramname"><em>semantic</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">unsigned short&#160;</td>
          <td class="paramname"><em>index</em> = <code>0</code>&#160;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td><code> [virtual]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>See <a class="el" href="classOgre_1_1VertexDeclaration.html" title="This class declares the format of a set of vertex inputs, which can be issued to the rendering API th...">VertexDeclaration</a>. </p>

<p>Reimplemented from <a class="el" href="classOgre_1_1VertexDeclaration.html#acf877a67096cf85fce47757010b531b1">Ogre::VertexDeclaration</a>.</p>

</div>
</div>
<a class="anchor" id="afe9b5394456063cae5b95d512cc54cc0"></a><!-- doxytag: member="Ogre::D3D9VertexDeclaration::notifyOnDeviceCreate" ref="afe9b5394456063cae5b95d512cc54cc0" args="(IDirect3DDevice9 *d3d9Device)" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">virtual void <a class="el" href="classOgre_1_1D3D9VertexDeclaration.html#afe9b5394456063cae5b95d512cc54cc0">Ogre::D3D9VertexDeclaration::notifyOnDeviceCreate</a> </td>
          <td>(</td>
          <td class="paramtype">IDirect3DDevice9 *&#160;</td>
          <td class="paramname"><em>d3d9Device</em></td><td>)</td>
          <td><code> [virtual]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>Reimplemented from <a class="el" href="classOgre_1_1D3D9Resource.html#ac2b865b0cd4754552c38fd6c6f83064f">Ogre::D3D9Resource</a>.</p>

</div>
</div>
<a class="anchor" id="a5a91d9a841eca45392494b2444968029"></a><!-- doxytag: member="Ogre::D3D9VertexDeclaration::notifyOnDeviceDestroy" ref="a5a91d9a841eca45392494b2444968029" args="(IDirect3DDevice9 *d3d9Device)" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">virtual void <a class="el" href="classOgre_1_1D3D9VertexDeclaration.html#a5a91d9a841eca45392494b2444968029">Ogre::D3D9VertexDeclaration::notifyOnDeviceDestroy</a> </td>
          <td>(</td>
          <td class="paramtype">IDirect3DDevice9 *&#160;</td>
          <td class="paramname"><em>d3d9Device</em></td><td>)</td>
          <td><code> [virtual]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>Reimplemented from <a class="el" href="classOgre_1_1D3D9Resource.html#a1ceaf6c7f17b55a2dfb818360bb8a97b">Ogre::D3D9Resource</a>.</p>

</div>
</div>
<a class="anchor" id="a8d55f1d5ce61a1b796d8d86dd3c69fdb"></a><!-- doxytag: member="Ogre::D3D9VertexDeclaration::notifyOnDeviceLost" ref="a8d55f1d5ce61a1b796d8d86dd3c69fdb" args="(IDirect3DDevice9 *d3d9Device)" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">virtual void <a class="el" href="classOgre_1_1D3D9Resource.html#a8d55f1d5ce61a1b796d8d86dd3c69fdb">Ogre::D3D9Resource::notifyOnDeviceLost</a> </td>
          <td>(</td>
          <td class="paramtype">IDirect3DDevice9 *&#160;</td>
          <td class="paramname"><em>d3d9Device</em></td><td>)</td>
          <td><code> [virtual, inherited]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>Reimplemented in <a class="el" href="classOgre_1_1D3D9Texture.html#a87c0bc1fea93de0e2cd65fa2dc374fd8">Ogre::D3D9Texture</a>, <a class="el" href="classOgre_1_1D3D9HardwareOcclusionQuery.html#a6dea06e309f77051404ae1e0fb761e39">Ogre::D3D9HardwareOcclusionQuery</a>, <a class="el" href="classOgre_1_1D3D9HardwareIndexBuffer.html#ab23fb340055333aee5801dbabea1fd6d">Ogre::D3D9HardwareIndexBuffer</a>, and <a class="el" href="classOgre_1_1D3D9HardwareVertexBuffer.html#ae3e1077c9d54bb6bcb9f8cdc68da1dd1">Ogre::D3D9HardwareVertexBuffer</a>.</p>

<p>Definition at line <a class="el" href="OgreD3D9Resource_8h_source.html#l00053">53</a> of file <a class="el" href="OgreD3D9Resource_8h_source.html">OgreD3D9Resource.h</a>.</p>

</div>
</div>
<a class="anchor" id="a9008da922e8b8762ac284cc1f08a0749"></a><!-- doxytag: member="Ogre::D3D9VertexDeclaration::notifyOnDeviceReset" ref="a9008da922e8b8762ac284cc1f08a0749" args="(IDirect3DDevice9 *d3d9Device)" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">virtual void <a class="el" href="classOgre_1_1D3D9Resource.html#a9008da922e8b8762ac284cc1f08a0749">Ogre::D3D9Resource::notifyOnDeviceReset</a> </td>
          <td>(</td>
          <td class="paramtype">IDirect3DDevice9 *&#160;</td>
          <td class="paramname"><em>d3d9Device</em></td><td>)</td>
          <td><code> [virtual, inherited]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>Reimplemented in <a class="el" href="classOgre_1_1D3D9Texture.html#adc3440ed2fd6447de424908e650b86ae">Ogre::D3D9Texture</a>, <a class="el" href="classOgre_1_1D3D9HardwareOcclusionQuery.html#a25a10de153b672d9a7a64278cd57eeae">Ogre::D3D9HardwareOcclusionQuery</a>, <a class="el" href="classOgre_1_1D3D9HardwareIndexBuffer.html#a739f49c9d66d04445cb306cf548fed06">Ogre::D3D9HardwareIndexBuffer</a>, and <a class="el" href="classOgre_1_1D3D9HardwareVertexBuffer.html#aa0edb44f392cdaacb8f77acebd16b739">Ogre::D3D9HardwareVertexBuffer</a>.</p>

<p>Definition at line <a class="el" href="OgreD3D9Resource_8h_source.html#l00057">57</a> of file <a class="el" href="OgreD3D9Resource_8h_source.html">OgreD3D9Resource.h</a>.</p>

</div>
</div>
<a class="anchor" id="a8357fe4fb4849772b94baa4bf47c7ded"></a><!-- doxytag: member="Ogre::D3D9VertexDeclaration::operator delete" ref="a8357fe4fb4849772b94baa4bf47c7ded" args="(void *ptr)" -->
<div class="memitem">
<div class="memproto">
<div class="memtemplate">
template&lt;class Alloc &gt; </div>
      <table class="memname">
        <tr>
          <td class="memname">void <a class="el" href="classOgre_1_1AllocatedObject.html">Ogre::AllocatedObject</a>&lt; Alloc &gt;::operator delete </td>
          <td>(</td>
          <td class="paramtype">void *&#160;</td>
          <td class="paramname"><em>ptr</em></td><td>)</td>
          <td><code> [inherited]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>Definition at line <a class="el" href="OgreMemoryAllocatedObject_8h_source.html#l00095">95</a> of file <a class="el" href="OgreMemoryAllocatedObject_8h_source.html">OgreMemoryAllocatedObject.h</a>.</p>

</div>
</div>
<a class="anchor" id="a1c727e879a260c37b00ce5505fe8e144"></a><!-- doxytag: member="Ogre::D3D9VertexDeclaration::operator delete" ref="a1c727e879a260c37b00ce5505fe8e144" args="(void *ptr, void *)" -->
<div class="memitem">
<div class="memproto">
<div class="memtemplate">
template&lt;class Alloc &gt; </div>
      <table class="memname">
        <tr>
          <td class="memname">void <a class="el" href="classOgre_1_1AllocatedObject.html">Ogre::AllocatedObject</a>&lt; Alloc &gt;::operator delete </td>
          <td>(</td>
          <td class="paramtype">void *&#160;</td>
          <td class="paramname"><em>ptr</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">void *&#160;</td>
          <td class="paramname">&#160;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td><code> [inherited]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>Definition at line <a class="el" href="OgreMemoryAllocatedObject_8h_source.html#l00101">101</a> of file <a class="el" href="OgreMemoryAllocatedObject_8h_source.html">OgreMemoryAllocatedObject.h</a>.</p>

</div>
</div>
<a class="anchor" id="acb46d4b0a597156d9ba5abc39d127792"></a><!-- doxytag: member="Ogre::D3D9VertexDeclaration::operator delete" ref="acb46d4b0a597156d9ba5abc39d127792" args="(void *ptr, const char *, int, const char *)" -->
<div class="memitem">
<div class="memproto">
<div class="memtemplate">
template&lt;class Alloc &gt; </div>
      <table class="memname">
        <tr>
          <td class="memname">void <a class="el" href="classOgre_1_1AllocatedObject.html">Ogre::AllocatedObject</a>&lt; Alloc &gt;::operator delete </td>
          <td>(</td>
          <td class="paramtype">void *&#160;</td>
          <td class="paramname"><em>ptr</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">const char *&#160;</td>
          <td class="paramname">, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">int&#160;</td>
          <td class="paramname">, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">const char *&#160;</td>
          <td class="paramname">&#160;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td><code> [inherited]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>Definition at line <a class="el" href="OgreMemoryAllocatedObject_8h_source.html#l00107">107</a> of file <a class="el" href="OgreMemoryAllocatedObject_8h_source.html">OgreMemoryAllocatedObject.h</a>.</p>

</div>
</div>
<a class="anchor" id="a93e6a86dde5483c053ca0f2a85bbfd6c"></a><!-- doxytag: member="Ogre::D3D9VertexDeclaration::operator delete[]" ref="a93e6a86dde5483c053ca0f2a85bbfd6c" args="(void *ptr)" -->
<div class="memitem">
<div class="memproto">
<div class="memtemplate">
template&lt;class Alloc &gt; </div>
      <table class="memname">
        <tr>
          <td class="memname">void <a class="el" href="classOgre_1_1AllocatedObject.html">Ogre::AllocatedObject</a>&lt; Alloc &gt;::operator delete[] </td>
          <td>(</td>
          <td class="paramtype">void *&#160;</td>
          <td class="paramname"><em>ptr</em></td><td>)</td>
          <td><code> [inherited]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>Definition at line <a class="el" href="OgreMemoryAllocatedObject_8h_source.html#l00112">112</a> of file <a class="el" href="OgreMemoryAllocatedObject_8h_source.html">OgreMemoryAllocatedObject.h</a>.</p>

</div>
</div>
<a class="anchor" id="a595ea4c05da8aa987d3800e65d23355d"></a><!-- doxytag: member="Ogre::D3D9VertexDeclaration::operator delete[]" ref="a595ea4c05da8aa987d3800e65d23355d" args="(void *ptr, const char *, int, const char *)" -->
<div class="memitem">
<div class="memproto">
<div class="memtemplate">
template&lt;class Alloc &gt; </div>
      <table class="memname">
        <tr>
          <td class="memname">void <a class="el" href="classOgre_1_1AllocatedObject.html">Ogre::AllocatedObject</a>&lt; Alloc &gt;::operator delete[] </td>
          <td>(</td>
          <td class="paramtype">void *&#160;</td>
          <td class="paramname"><em>ptr</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">const char *&#160;</td>
          <td class="paramname">, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">int&#160;</td>
          <td class="paramname">, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">const char *&#160;</td>
          <td class="paramname">&#160;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td><code> [inherited]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>Definition at line <a class="el" href="OgreMemoryAllocatedObject_8h_source.html#l00118">118</a> of file <a class="el" href="OgreMemoryAllocatedObject_8h_source.html">OgreMemoryAllocatedObject.h</a>.</p>

</div>
</div>
<a class="anchor" id="a421b197ca3a38da17e2eb1531a645fa2"></a><!-- doxytag: member="Ogre::D3D9VertexDeclaration::operator new" ref="a421b197ca3a38da17e2eb1531a645fa2" args="(size_t sz, const char *file, int line, const char *func)" -->
<div class="memitem">
<div class="memproto">
<div class="memtemplate">
template&lt;class Alloc &gt; </div>
      <table class="memname">
        <tr>
          <td class="memname">void* <a class="el" href="classOgre_1_1AllocatedObject.html">Ogre::AllocatedObject</a>&lt; Alloc &gt;::operator new </td>
          <td>(</td>
          <td class="paramtype">size_t&#160;</td>
          <td class="paramname"><em>sz</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">const char *&#160;</td>
          <td class="paramname"><em>file</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">int&#160;</td>
          <td class="paramname"><em>line</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">const char *&#160;</td>
          <td class="paramname"><em>func</em>&#160;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td><code> [inherited]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>operator new, with debug line info </p>

<p>Definition at line <a class="el" href="OgreMemoryAllocatedObject_8h_source.html#l00067">67</a> of file <a class="el" href="OgreMemoryAllocatedObject_8h_source.html">OgreMemoryAllocatedObject.h</a>.</p>

</div>
</div>
<a class="anchor" id="ac4bdf968b7b9af8a5239a27da73d5711"></a><!-- doxytag: member="Ogre::D3D9VertexDeclaration::operator new" ref="ac4bdf968b7b9af8a5239a27da73d5711" args="(size_t sz)" -->
<div class="memitem">
<div class="memproto">
<div class="memtemplate">
template&lt;class Alloc &gt; </div>
      <table class="memname">
        <tr>
          <td class="memname">void* <a class="el" href="classOgre_1_1AllocatedObject.html">Ogre::AllocatedObject</a>&lt; Alloc &gt;::operator new </td>
          <td>(</td>
          <td class="paramtype">size_t&#160;</td>
          <td class="paramname"><em>sz</em></td><td>)</td>
          <td><code> [inherited]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>Definition at line <a class="el" href="OgreMemoryAllocatedObject_8h_source.html#l00072">72</a> of file <a class="el" href="OgreMemoryAllocatedObject_8h_source.html">OgreMemoryAllocatedObject.h</a>.</p>

</div>
</div>
<a class="anchor" id="ab78a921e54419be677839cdf15d1f0b8"></a><!-- doxytag: member="Ogre::D3D9VertexDeclaration::operator new" ref="ab78a921e54419be677839cdf15d1f0b8" args="(size_t sz, void *ptr)" -->
<div class="memitem">
<div class="memproto">
<div class="memtemplate">
template&lt;class Alloc &gt; </div>
      <table class="memname">
        <tr>
          <td class="memname">void* <a class="el" href="classOgre_1_1AllocatedObject.html">Ogre::AllocatedObject</a>&lt; Alloc &gt;::operator new </td>
          <td>(</td>
          <td class="paramtype">size_t&#160;</td>
          <td class="paramname"><em>sz</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">void *&#160;</td>
          <td class="paramname"><em>ptr</em>&#160;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td><code> [inherited]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>placement operator new </p>

<p>Definition at line <a class="el" href="OgreMemoryAllocatedObject_8h_source.html#l00078">78</a> of file <a class="el" href="OgreMemoryAllocatedObject_8h_source.html">OgreMemoryAllocatedObject.h</a>.</p>

</div>
</div>
<a class="anchor" id="a4be37baef81876985aa1071ad5acc6dd"></a><!-- doxytag: member="Ogre::D3D9VertexDeclaration::operator new[]" ref="a4be37baef81876985aa1071ad5acc6dd" args="(size_t sz, const char *file, int line, const char *func)" -->
<div class="memitem">
<div class="memproto">
<div class="memtemplate">
template&lt;class Alloc &gt; </div>
      <table class="memname">
        <tr>
          <td class="memname">void* <a class="el" href="classOgre_1_1AllocatedObject.html">Ogre::AllocatedObject</a>&lt; Alloc &gt;::operator new[] </td>
          <td>(</td>
          <td class="paramtype">size_t&#160;</td>
          <td class="paramname"><em>sz</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">const char *&#160;</td>
          <td class="paramname"><em>file</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">int&#160;</td>
          <td class="paramname"><em>line</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">const char *&#160;</td>
          <td class="paramname"><em>func</em>&#160;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td><code> [inherited]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>array operator new, with debug line info </p>

<p>Definition at line <a class="el" href="OgreMemoryAllocatedObject_8h_source.html#l00085">85</a> of file <a class="el" href="OgreMemoryAllocatedObject_8h_source.html">OgreMemoryAllocatedObject.h</a>.</p>

</div>
</div>
<a class="anchor" id="afa2943846ba6a2b5824a12857139cf5e"></a><!-- doxytag: member="Ogre::D3D9VertexDeclaration::operator new[]" ref="afa2943846ba6a2b5824a12857139cf5e" args="(size_t sz)" -->
<div class="memitem">
<div class="memproto">
<div class="memtemplate">
template&lt;class Alloc &gt; </div>
      <table class="memname">
        <tr>
          <td class="memname">void* <a class="el" href="classOgre_1_1AllocatedObject.html">Ogre::AllocatedObject</a>&lt; Alloc &gt;::operator new[] </td>
          <td>(</td>
          <td class="paramtype">size_t&#160;</td>
          <td class="paramname"><em>sz</em></td><td>)</td>
          <td><code> [inherited]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>Definition at line <a class="el" href="OgreMemoryAllocatedObject_8h_source.html#l00090">90</a> of file <a class="el" href="OgreMemoryAllocatedObject_8h_source.html">OgreMemoryAllocatedObject.h</a>.</p>

</div>
</div>
<a class="anchor" id="a64989816c9979aac5a5416d488d547d5"></a><!-- doxytag: member="Ogre::D3D9VertexDeclaration::operator!=" ref="a64989816c9979aac5a5416d488d547d5" args="(const VertexDeclaration &amp;rhs) const " -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">bool Ogre::VertexDeclaration::operator!= </td>
          <td>(</td>
          <td class="paramtype">const <a class="el" href="classOgre_1_1VertexDeclaration.html">VertexDeclaration</a> &amp;&#160;</td>
          <td class="paramname"><em>rhs</em></td><td>)</td>
          <td> const<code> [inherited]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>Definition at line <a class="el" href="OgreHardwareVertexBuffer_8h_source.html#l00481">481</a> of file <a class="el" href="OgreHardwareVertexBuffer_8h_source.html">OgreHardwareVertexBuffer.h</a>.</p>

</div>
</div>
<a class="anchor" id="aee364dc39b2dfdbff4a5b135e5e5ef39"></a><!-- doxytag: member="Ogre::D3D9VertexDeclaration::operator==" ref="aee364dc39b2dfdbff4a5b135e5e5ef39" args="(const VertexDeclaration &amp;rhs) const " -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">bool Ogre::VertexDeclaration::operator== </td>
          <td>(</td>
          <td class="paramtype">const <a class="el" href="classOgre_1_1VertexDeclaration.html">VertexDeclaration</a> &amp;&#160;</td>
          <td class="paramname"><em>rhs</em></td><td>)</td>
          <td> const<code> [inherited]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>Definition at line <a class="el" href="OgreHardwareVertexBuffer_8h_source.html#l00464">464</a> of file <a class="el" href="OgreHardwareVertexBuffer_8h_source.html">OgreHardwareVertexBuffer.h</a>.</p>

<p>References <a class="el" href="OgreHardwareVertexBuffer_8h_source.html#l00325">Ogre::VertexDeclaration::mElementList</a>.</p>

</div>
</div>
<a class="anchor" id="a7cdd5882972af0c2730d814daeaa93e4"></a><!-- doxytag: member="Ogre::D3D9VertexDeclaration::releaseDeclaration" ref="a7cdd5882972af0c2730d814daeaa93e4" args="()" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">void <a class="el" href="classOgre_1_1D3D9VertexDeclaration.html#a7cdd5882972af0c2730d814daeaa93e4">Ogre::D3D9VertexDeclaration::releaseDeclaration</a> </td>
          <td>(</td>
          <td class="paramname"></td><td>)</td>
          <td><code> [protected]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">

</div>
</div>
<a class="anchor" id="a266542b0e2a78904d671f615b03b8080"></a><!-- doxytag: member="Ogre::D3D9VertexDeclaration::removeAllElements" ref="a266542b0e2a78904d671f615b03b8080" args="(void)" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">void <a class="el" href="classOgre_1_1D3D9VertexDeclaration.html#a266542b0e2a78904d671f615b03b8080">Ogre::D3D9VertexDeclaration::removeAllElements</a> </td>
          <td>(</td>
          <td class="paramtype">void&#160;</td>
          <td class="paramname"></td><td>)</td>
          <td><code> [virtual]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>See <a class="el" href="classOgre_1_1VertexDeclaration.html" title="This class declares the format of a set of vertex inputs, which can be issued to the rendering API th...">VertexDeclaration</a>. </p>

<p>Reimplemented from <a class="el" href="classOgre_1_1VertexDeclaration.html#a9c6df3f800c43118c49e30940445669f">Ogre::VertexDeclaration</a>.</p>

</div>
</div>
<a class="anchor" id="a8cb01902db67a5d34ccc02a5ff733fd1"></a><!-- doxytag: member="Ogre::D3D9VertexDeclaration::removeElement" ref="a8cb01902db67a5d34ccc02a5ff733fd1" args="(unsigned short elem_index)" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">void <a class="el" href="classOgre_1_1D3D9VertexDeclaration.html#a8cb01902db67a5d34ccc02a5ff733fd1">Ogre::D3D9VertexDeclaration::removeElement</a> </td>
          <td>(</td>
          <td class="paramtype">unsigned short&#160;</td>
          <td class="paramname"><em>elem_index</em></td><td>)</td>
          <td><code> [virtual]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>See <a class="el" href="classOgre_1_1VertexDeclaration.html" title="This class declares the format of a set of vertex inputs, which can be issued to the rendering API th...">VertexDeclaration</a>. </p>

<p>Reimplemented from <a class="el" href="classOgre_1_1VertexDeclaration.html#a2dc6358fb76e454d7ae30da4d014687c">Ogre::VertexDeclaration</a>.</p>

</div>
</div>
<a class="anchor" id="aaf846d91970816cbbe04bb3def85e2b6"></a><!-- doxytag: member="Ogre::D3D9VertexDeclaration::removeElement" ref="aaf846d91970816cbbe04bb3def85e2b6" args="(VertexElementSemantic semantic, unsigned short index=0)" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">void <a class="el" href="classOgre_1_1D3D9VertexDeclaration.html#a8cb01902db67a5d34ccc02a5ff733fd1">Ogre::D3D9VertexDeclaration::removeElement</a> </td>
          <td>(</td>
          <td class="paramtype"><a class="el" href="group__RenderSystem.html#ga0a62b3f2ede8992ff365bb013a8bc00d">VertexElementSemantic</a>&#160;</td>
          <td class="paramname"><em>semantic</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">unsigned short&#160;</td>
          <td class="paramname"><em>index</em> = <code>0</code>&#160;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td><code> [virtual]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>See <a class="el" href="classOgre_1_1VertexDeclaration.html" title="This class declares the format of a set of vertex inputs, which can be issued to the rendering API th...">VertexDeclaration</a>. </p>

<p>Reimplemented from <a class="el" href="classOgre_1_1VertexDeclaration.html#ad98b8d55cf8490d788ba46633143ef94">Ogre::VertexDeclaration</a>.</p>

</div>
</div>
<a class="anchor" id="a98cce285a45ba6f4cf817dcf46bfb588"></a><!-- doxytag: member="Ogre::D3D9VertexDeclaration::sort" ref="a98cce285a45ba6f4cf817dcf46bfb588" args="(void)" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">void <a class="el" href="classOgre_1_1VertexDeclaration.html#a98cce285a45ba6f4cf817dcf46bfb588">Ogre::VertexDeclaration::sort</a> </td>
          <td>(</td>
          <td class="paramtype">void&#160;</td>
          <td class="paramname"></td><td>)</td>
          <td><code> [inherited]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>Sorts the elements in this list to be compatible with the maximum number of rendering APIs / graphics cards. </p>
<dl class="remark"><dt><b>Remarks:</b></dt><dd>Older graphics cards require vertex data to be presented in a more rigid way, as defined in the main documentation for this class. As well as the ordering being important, where shared source buffers are used, the declaration must list all the elements for each source in turn. </dd></dl>

</div>
</div>
<a class="anchor" id="a6fc9c0ebe4a4c559b172f25f3b5dc9d8"></a><!-- doxytag: member="Ogre::D3D9VertexDeclaration::unlockDeviceAccess" ref="a6fc9c0ebe4a4c559b172f25f3b5dc9d8" args="()" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">static void <a class="el" href="classOgre_1_1D3D9Resource.html#a6fc9c0ebe4a4c559b172f25f3b5dc9d8">Ogre::D3D9Resource::unlockDeviceAccess</a> </td>
          <td>(</td>
          <td class="paramname"></td><td>)</td>
          <td><code> [static, inherited]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">

</div>
</div>
<a class="anchor" id="a670466fe9bcfc426ccefb5395a3a82ef"></a><!-- doxytag: member="Ogre::D3D9VertexDeclaration::vertexElementLess" ref="a670466fe9bcfc426ccefb5395a3a82ef" args="(const VertexElement &amp;e1, const VertexElement &amp;e2)" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">static bool <a class="el" href="classOgre_1_1VertexDeclaration.html#a670466fe9bcfc426ccefb5395a3a82ef">Ogre::VertexDeclaration::vertexElementLess</a> </td>
          <td>(</td>
          <td class="paramtype">const <a class="el" href="classOgre_1_1VertexElement.html">VertexElement</a> &amp;&#160;</td>
          <td class="paramname"><em>e1</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">const <a class="el" href="classOgre_1_1VertexElement.html">VertexElement</a> &amp;&#160;</td>
          <td class="paramname"><em>e2</em>&#160;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td><code> [static, inherited]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>Sort routine for vertex elements. </p>

</div>
</div>
<hr/><h2>Member Data Documentation</h2>
<a class="anchor" id="adc48aa31318d2384866eab90ee8406d5"></a><!-- doxytag: member="Ogre::D3D9VertexDeclaration::mElementList" ref="adc48aa31318d2384866eab90ee8406d5" args="" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname"><a class="el" href="classOgre_1_1VertexDeclaration.html#a3229cfa9d056740702853b27249c7181">VertexElementList</a> <a class="el" href="classOgre_1_1VertexDeclaration.html#adc48aa31318d2384866eab90ee8406d5">Ogre::VertexDeclaration::mElementList</a><code> [protected, inherited]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>Definition at line <a class="el" href="OgreHardwareVertexBuffer_8h_source.html#l00325">325</a> of file <a class="el" href="OgreHardwareVertexBuffer_8h_source.html">OgreHardwareVertexBuffer.h</a>.</p>

<p>Referenced by <a class="el" href="OgreHardwareVertexBuffer_8h_source.html#l00464">Ogre::VertexDeclaration::operator==()</a>.</p>

</div>
</div>
<a class="anchor" id="a6f366f7e06ffc70919f964d8ec7e597c"></a><!-- doxytag: member="Ogre::D3D9VertexDeclaration::mLastUsedGlobalDeclaration" ref="a6f366f7e06ffc70919f964d8ec7e597c" args="" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname"><a class="el" href="classOgre_1_1VertexDeclaration.html">VertexDeclaration</a>* <a class="el" href="classOgre_1_1D3D9VertexDeclaration.html#a6f366f7e06ffc70919f964d8ec7e597c">Ogre::D3D9VertexDeclaration::mLastUsedGlobalDeclaration</a><code> [protected]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>Definition at line <a class="el" href="OgreD3D9VertexDeclaration_8h_source.html#l00086">86</a> of file <a class="el" href="OgreD3D9VertexDeclaration_8h_source.html">OgreD3D9VertexDeclaration.h</a>.</p>

</div>
</div>
<a class="anchor" id="aa5d8572399731ad358b8eeb4039e889c"></a><!-- doxytag: member="Ogre::D3D9VertexDeclaration::mMapDeviceToDeclaration" ref="aa5d8572399731ad358b8eeb4039e889c" args="" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname"><a class="el" href="classOgre_1_1D3D9VertexDeclaration.html#acb454d7ad730f5018514cf2204d02a2d">DeviceToDeclarationMap</a> <a class="el" href="classOgre_1_1D3D9VertexDeclaration.html#aa5d8572399731ad358b8eeb4039e889c">Ogre::D3D9VertexDeclaration::mMapDeviceToDeclaration</a><code> [protected]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>Definition at line <a class="el" href="OgreD3D9VertexDeclaration_8h_source.html#l00085">85</a> of file <a class="el" href="OgreD3D9VertexDeclaration_8h_source.html">OgreD3D9VertexDeclaration.h</a>.</p>

</div>
</div>
<a class="anchor" id="af135e2be5d157faf75601b06d5c1f57c"></a><!-- doxytag: member="Ogre::D3D9VertexDeclaration::mUsedGlobalDeclaration" ref="af135e2be5d157faf75601b06d5c1f57c" args="" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">bool <a class="el" href="classOgre_1_1D3D9VertexDeclaration.html#af135e2be5d157faf75601b06d5c1f57c">Ogre::D3D9VertexDeclaration::mUsedGlobalDeclaration</a><code> [protected]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>Definition at line <a class="el" href="OgreD3D9VertexDeclaration_8h_source.html#l00087">87</a> of file <a class="el" href="OgreD3D9VertexDeclaration_8h_source.html">OgreD3D9VertexDeclaration.h</a>.</p>

</div>
</div>
<hr/>The documentation for this class was generated from the following file:<ul>
<li><a class="el" href="OgreD3D9VertexDeclaration_8h_source.html">OgreD3D9VertexDeclaration.h</a></li>
</ul>
</div><!-- contents -->
<hr>
<p>
Copyright &copy; 2012 Torus Knot Software Ltd<br />
<!--Creative Commons License--><a rel="license" href="http://creativecommons.org/licenses/by-sa/3.0/"><img alt="Creative Commons License" style="border-width:0" src="http://i.creativecommons.org/l/by-sa/3.0/88x31.png" /></a><br />This work is licensed under a <a rel="license" href="http://creativecommons.org/licenses/by-sa/3.0/">Creative Commons Attribution-ShareAlike 3.0 Unported License</a>.<br/>
		<!--/Creative Commons License--><!-- <rdf:RDF xmlns="http://web.resource.org/cc/" xmlns:dc="http://purl.org/dc/elements/1.1/" xmlns:rdf="http://www.w3.org/1999/02/22-rdf-syntax-ns#">
		<Work rdf:about="">
			<license rdf:resource="http://creativecommons.org/licenses/by-sa/2.5/" />
	<dc:type rdf:resource="http://purl.org/dc/dcmitype/Text" />
		</Work>
		<License rdf:about="http://creativecommons.org/licenses/by-sa/2.5/"><permits rdf:resource="http://web.resource.org/cc/Reproduction"/><permits rdf:resource="http://web.resource.org/cc/Distribution"/><requires rdf:resource="http://web.resource.org/cc/Notice"/><requires rdf:resource="http://web.resource.org/cc/Attribution"/><permits rdf:resource="http://web.resource.org/cc/DerivativeWorks"/><requires rdf:resource="http://web.resource.org/cc/ShareAlike"/></License></rdf:RDF> -->

Last modified Fri May 25 2012 21:49:17
</p>
</body>
</html>
